// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _HILDON_NOTIFYMM_FILE_SELECTION_H
#define _HILDON_NOTIFYMM_FILE_SELECTION_H


#include <glibmm.h>

/*
 * Copyright 2006-2007 The maemomm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/container.h>
#include <gtkmm/filefilter.h>
#include <hildon-notifymm/file-system-model.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _HildonFileSelection HildonFileSelection;
typedef struct _HildonFileSelectionClass HildonFileSelectionClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Hildon
{ class FileSelection_Class; } // namespace Hildon
namespace Hildon
{

//TODO: Remove NO_GTYPE this when the header is in a distributed hildon-notify version
//(It is in trunk):
//
//gtkmmproc error: HildonFileSelectionMode : enum defs lookup failed.
//gtkmmproc error: HildonFileSelectionPane : enum defs lookup failed.
//gtkmmproc error: HildonFileSelectionSortKey : enum defs lookup failed.

//TODO: Is this really public API?

/** @defgroup HildonWidgets Widgets
 */

/** A file tree widget.
 *
 * @ingroup HildonWidgets
 * @ingroup HildonFileSystem
 */

class FileSelection
  : public Gtk::Container
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef FileSelection CppObjectType;
  typedef FileSelection_Class CppClassType;
  typedef HildonFileSelection BaseObjectType;
  typedef HildonFileSelectionClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~FileSelection();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class FileSelection_Class;
  static CppClassType fileselection_class_;

  // noncopyable
  FileSelection(const FileSelection&);
  FileSelection& operator=(const FileSelection&);

protected:
  explicit FileSelection(const Glib::ConstructParams& construct_params);
  explicit FileSelection(HildonFileSelection* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  HildonFileSelection*       gobj()       { return reinterpret_cast<HildonFileSelection*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const HildonFileSelection* gobj() const { return reinterpret_cast<HildonFileSelection*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
  virtual void on_current_folder_changed();
  virtual void on_file_activated();
  virtual void on_selection_changed();
  virtual void on_navigation_pane_context_menu();
  virtual void on_content_pane_context_menu();
  virtual void on_location_insensitive(const Gtk::TreeModel::iterator& iter);
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:

public:
  //gtkmmproc error: hildon_file_selection_new_with_model : ctor defs lookup failed (2)

//GtkFilePath and char* seem to be equivalent, though maybe that's a non-guaranteed implementation details.
//GtkFilePath is not public API anyway.
//For instance, see gtk_file_system_unix_path_to_filename(), which uses gtk_file_path_get_string
 

  //gtkmmproc error: hildon_file_selection_set_mode : method defs lookup failed (1)
  //gtkmmproc error: hildon_file_selection_get_mode : method defs lookup failed (1)
  //gtkmmproc error: hildon_file_selection_set_sort_key : method defs lookup failed (1)
  //gtkmmproc error: hildon_file_selection_get_sort_key : method defs lookup failed (1)

  //gtkmmproc error: hildon_file_selection_set_current_folder_uri : method defs lookup failed (1)

   
  //gtkmmproc error: hildon_file_selection_get_current_folder_uri : method defs lookup failed (1)

  /** Retrieves an iterator to match the currently selected item in the 
   * navigation pane. Internally this gets the selection from the
   * tree and then the current iterator from the selection and converts
   * the result accordingly.
   *
   * @result A valid iterator, if the given iterator is set, or an invalid iterator if none is set.
   */
  Gtk::TreeModel::iterator get_current_folder_iter() const;
  

  //gtkmmproc error: hildon_file_selection_select_uri : method defs lookup failed (1)
  //gtkmmproc error: hildon_file_selection_unselect_uri : method defs lookup failed (1)

  //gtkmmproc error: hildon_file_selection_select_all : method defs lookup failed (1)
  //gtkmmproc error: hildon_file_selection_unselect_all : method defs lookup failed (1)
  //gtkmmproc error: hildon_file_selection_clear_multi_selection : method defs lookup failed (1)

  // TODO: return a StringListHandle instead and add a const version.
  //gtkmmproc error: hildon_file_selection_get_selected_uris : method defs lookup failed (1)

  //gtkmmproc error: hildon_file_selection_set_select_multiple : method defs lookup failed (1)
  //gtkmmproc error: hildon_file_selection_get_select_multiple : method defs lookup failed (1)

  //gtkmmproc error: hildon_file_selection_set_column_headers_visible : method defs lookup failed (1)
  //gtkmmproc error: hildon_file_selection_get_column_headers_visible : method defs lookup failed (1)

  //gtkmmproc error: hildon_file_selection_set_filter : method defs lookup failed (1)
  //gtkmmproc error: hildon_file_selection_get_filter : method defs lookup failed (1)
  //gtkmmproc error: hildon_file_selection_get_filter : method defs lookup failed (1)

  //gtkmmproc error: hildon_file_selection_dim_current_selection : method defs lookup failed (1)
  //gtkmmproc error: hildon_file_selection_undim_all : method defs lookup failed (1)

  //gtkmmproc error: hildon_file_selection_get_active_pane : method defs lookup failed (1)

  //gtkmmproc error: hildon_file_selection_hide_content_pane : method defs lookup failed (1)
  //gtkmmproc error: hildon_file_selection_show_content_pane : method defs lookup failed (1)

  //gtkmmproc error: hildon_file_selection_move_cursor_to_uri : method defs lookup failed (1)

  //Ignoring deprecated functions.
  
  
   /**
   * @par Prototype:
   * <tt>void %current_folder_changed()</tt>
   */

  Glib::SignalProxy0< void > signal_current_folder_changed();

  
   /**
   * @par Prototype:
   * <tt>void %file_activated()</tt>
   */

  Glib::SignalProxy0< void > signal_file_activated();

  
   /**
   * @par Prototype:
   * <tt>void %selection_changed()</tt>
   */

  Glib::SignalProxy0< void > signal_selection_changed();

  
   /**
   * @par Prototype:
   * <tt>void %navigation_pane_context_menu()</tt>
   */

  Glib::SignalProxy0< void > signal_navigation_pane_context_menu();

  
   /**
   * @par Prototype:
   * <tt>void %content_pane_context_menu()</tt>
   */

  Glib::SignalProxy0< void > signal_content_pane_context_menu();

  //TODO_Maybe: _WRAP_SIGNAL(void location_insensitive(GtkTreeIter *iter), "location_insensitive")
  //TODO_Maybe: _WRAP_SIGNAL(void (*uris_dropped) (const char *destination, GSList * sources), "uris-dropped")


   /**
   * @par Prototype:
   * <tt>void %location_insensitive(const Gtk::TreeModel::iterator& iter)</tt>
   */

  Glib::SignalProxy1< void,const Gtk::TreeModel::iterator& > signal_location_insensitive();


  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Set the HildonFileSystemModel to display.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Glib::RefPtr<FileSystemModel> > property_model() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Ask file selection to enable drag'n'drop support.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<bool> property_drag_enabled() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  #ifdef GLIBMM_PROPERTIES_ENABLED
/** String to use when selected folder is empty.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Glib::ustring> property_empty_text() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** String to use when selected folder is empty.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_empty_text() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Defines the columns shown on content pane.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<int> property_visible_columns() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  //_WRAP_PROPERTY("safe-folder", GtkFilePath*) //TODO_maybe: GtkFilePath* is not public API, so we don't have a wrapper for it.
  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Which pane (navigation or content) has (or last time had) active focus.This in formation can be used to find which pane should be used to query selection.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<int> property_active_pane() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Which pane (navigation or content) has (or last time had) active focus.This in formation can be used to find which pane should be used to query selection.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<int> property_active_pane() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Show hidden files in file selector widgets.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<bool> property_show_hidden() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Show hidden files in file selector widgets.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<bool> property_show_hidden() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Whether or not all the displayed items should have a local file path.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<bool> property_local_only() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Whether or not all the displayed items should have a local file path.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<bool> property_local_only() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Whether or not to show UPNP devices.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<bool> property_show_upnp() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Whether or not to show UPNP devices.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<bool> property_show_upnp() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


};

} // namespace Hildon


namespace Glib
{
  /** @relates Hildon::FileSelection
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Hildon::FileSelection* wrap(HildonFileSelection* object, bool take_copy = false);
} //namespace Glib


#endif /* _HILDON_NOTIFYMM_FILE_SELECTION_H */

